<?php
// Image extensions accepted
define ('_IMAGES_ACCEPTEES', "(.*)\.(jpg|JPG|jpeg|JPEG|gif|GIF|png|PNG)");

//////////////////////////////////////////////////////////////////////////////////////
function mkdir_recursive($pathname, $mode)
 {
     is_dir(dirname($pathname)) || mkdir_recursive(dirname($pathname), $mode);
     return is_dir($pathname) || @mkdir($pathname, $mode);
 }

//////////////////////////////////////////////////////////////////////////////////////
/* ---- Crée la miniature d'un fichier donné ---- */
function cree_mini($dossier,$fichier,$ou,$hauteur,$entrelacee,$strict=0) {
  # $taille contient [ largeur, hauteur, type, taille_html ]
  $taille = getimagesize("$dossier/$fichier");
  $mini_hauteur = $hauteur;
  $mini_largeur = ($taille[0]*$hauteur/$taille[1]);
  // strict évite qu'une image panoramique déborde de smooth slideshow
  if( ($strict>0) && ($mini_largeur > $strict) ) {
          $mini_largeur=$strict;
          $mini_hauteur = ($taille[1]*$mini_largeur/$taille[0]);
  }

  switch (strtolower(substr($fichier,-3))){
    case 'gif' : $grosse = imagecreatefromgif("$dossier/$fichier");break;
    case 'png' : $grosse = imagecreatefrompng("$dossier/$fichier");break;
    default : $grosse = imagecreatefromjpeg("$dossier/$fichier");break;
  }
  $mini = imagecreatetruecolor($mini_largeur,$mini_hauteur);
  
  # réduction
  imagecopyresampled($mini, $grosse, 0, 0, 0, 0, $mini_largeur, $mini_hauteur, $taille[0], $taille[1]);
  imagedestroy($grosse);
  
  # écriture sur le disque
  imageinterlace($mini,$entrelacee);//entrelace pour le cache
  is_dir("$ou/$dossier") || mkdir_recursive("$ou/$dossier",0770);
  switch (strtolower(substr($fichier,-3))){
    case 'gif' : $grosse = imagegif($mini, "$ou/$dossier/$fichier");break;
    case 'png' : $grosse = imagepng($mini, "$ou/$dossier/$fichier");break;
    default : $grosse = imagejpeg($mini, "$ou/$dossier/$fichier", 75);break;
  }
  imagedestroy($mini);
}

//////////////////////////////////////////////////////////////////////////////////////
// tells if a ogv file with the same name exists, so we don't show it
function is_video($file_name)
{
	$file_ogg = substr_replace($file_name, 'ogv', strlen($file_name)-3);
	if (file_exists("$file_ogg")) return TRUE; else return FALSE;
}

//////////////////////////////////////////////////////////////////////////////////////
// extract all the comments
function commentaires( $image_path ) {    $ret=array('keyword'=>'','commentaire'=>'');
	// Recherche d'un fichier texte UTF-8
	if ( file_exists( substr_replace($image_path, 'txt', strlen($image_path)-3) ) ) {
		// Lit un fichier, et le place dans une chaîne
		$handle = fopen(substr_replace($image_path, 'txt', strlen($image_path)-3), "r");
		$ret['commentaire'] = fread($handle, filesize(substr_replace($image_path, 'txt', strlen($image_path)-3))).' ';
		fclose($handle);
	}
	// Recherche d'informations ITPC
	$size = getimagesize ( $image_path, $info);        
	if(is_array($info) && isset($info["APP13"])) {    
		$iptc = iptcparse($info["APP13"]);
		if(is_array($iptc))
			foreach (array_keys($iptc) as $s) {              
				$c = count ($iptc[$s]);
				for ($i=0; $i <$c; $i++) {
					$i==$c-2 ? $fin=' & ' : $fin=', ';
					if($s=='2#025')$ret['keyword'].= $iptc[$s][$i].$fin;
					if($s=='2#120')$ret['commentaire'].= mb_convert_encoding($iptc[$s][$i],'UTF-8');
			}
		}
	$ret['keyword'] = substr($ret['keyword'],0,-2);
	}
	return $ret;
}
?>