<?php
// Tableau des langues courantes... pour alt_download et podcast
$languages = array( 1 => "ca", 2 => "cs", 3 => "de", 4 => "en", 5 => "es", 
6 => "eo", 7 => "fr", 8 => "it", 9 => "hu", 10 => "nl", 11 => "ja", 12 => "no", 13 => "pl", 
14 => "pt", 15 => "ro", 16 => "sk", 17 => "fi", 18 => "sv", 19 => "tr", 20 => "uk", 21 => "vo", 
22 => "zh" );

// ----------------------------------------------------- Fonctions
// Fonction pour recuperer le parametre via POST ou GET
function getp($p) {
	if (isset($_GET[$p])) return ($_GET[$p]);
	if (isset($_POST[$p])) return ($_POST[$p]);
	return (false);
} 

// Fonction pour simplifier l'affichage du texte
function isUTF8($string){
   return (utf8_encode(utf8_decode($string)) == $string);
} 

function txt($text) {
	return (isUTF8($text) ? htmlentities($text, ENT_QUOTES, 'UTF-8') : htmlentities($text, ENT_QUOTES, 'ISO-8859-1'));
}

function txtjs($text) {
	$text = str_replace("\n",'', $text);
	$text = str_replace("\r",'', $text);
	$text = str_replace("\t",'', $text);
	$text = str_replace("'","\'", $text);
	return $text;
}

function linktitle($tooltip) { // Fonction affichage du titre active
		return 'title="'.$tooltip.'" onmouseover="infobulle(\' '.$tooltip.' \')" onmouseout="infobulle()"';
}


// Fonction pour reecrire l'eperluette et le point d'interrogation en passant
function ep($text, $type) {
	switch ($type) {
		case 0 :	$text = str_replace("&", '%26', $text); break; // & convertis en base 16
		case 1 :	$text = str_replace("&", '&amp;', $text); break;// & convertis en &amp
		case 2 :	$text = str_replace("&", '&amp;amp;', $text); break; // & convertis en &amp;amp;
	}
	$text = str_replace("?", '%3F', $text); // ? convertis en base 16
	return $text;
}

function get_extra_query () {

$iquery = array( 1 => "v", 2 => "n", 3 => "t", 4 => "d", 5 => "s",
6 => "l", 7 => "x", 8 => "w", 9 => "h", 10 => "p", 11 => "b", 12 => "f",
13 => "out", 14 => "reload" );
	$url='';
	foreach ($_GET as $k => $v) {
	$url .= '&'.$k.'='.$v;
	}
	for($i=1; $i<=count($iquery); $i++) {
		if(isset($_GET[$iquery[$i]])) {
			$url=str_replace('&'.$iquery[$i].'='.$_GET[$iquery[$i]], '', $url);
		}
	}
	return $url;
}

function url_to_file($url) {
	$file=substr(strrchr($url, '/'), 1);
	return $file;
}

function url_to_ext($url) {
	$file=substr(strrchr($url, '.'), 1);
	return $file;
}

// Fonction pour tester l'url
function url_exists ($url, $ext) {
	$handle = @fopen ($url, "r");
	if($handle) {
		switch ($ext) {
			case "ogg" : $file = (@fread ($handle, 4)=="OggS"); break; // utilise uniquement lorsque la video est en flash (pb de redirection)
			case "jpg" : $file = (@fread ($handle, 4)==""); break;
			case "torrent" : $file = (@fread ($handle, 4)=="d8:a"); break;
			case "xml" : $file = (@fread ($handle, 4)=="<?xm"); break;
			case "ext" : $start=@fread ($handle, 4); $file = (($start!="<!DO") && ($start!="<htm")); break; // verifie juste que l'extension est bonne et n'est pas une page html de redirection ou autre
			case "html" : $start=@fread ($handle, 4); $file = (($start=="<!DO") || ($start=="<htm")); break;
		}
		@fclose ($handle);
		return $file;
	} else { 
		return false;
	}
}

function s_to_h ($duration) {
	$hour = intval($duration/3600); $min = intval(($duration%3600)/60); $sec = ($duration%3600)%60;
	if ($min < 10) $min = "0".$min; if ($sec < 10) $sec = "0".$sec;
	if(!empty($hour)) { 
		return $hour.':'.$min.':'.$sec;
	} else {
		return $min.':'.$sec;
	}
}

function h_to_s ($duration) {
	if(strlen($duration)==8) {
		$hour = substr($duration, -8,2); $min = substr($duration,-5,2); $sec = substr($duration,-2,2);
		return (3600*$hour+60*$min+1*$sec);
	} else if(strlen($duration)==7) {
		$hour = substr($duration, -7,1); $min = substr($duration,-5,2); $sec = substr($duration,-2,2);
		return (3600*$hour+60*$min+1*$sec);
	} else if(strlen($duration)==5) {
		$min = substr($duration,-5,2); $sec = substr($duration,-2,2);
		return (60*$min+1*$sec);
	} else if(strlen($duration)==4) {
		$min = substr($duration,-4,1); $sec = substr($duration,-2,2);
		return (60*$min+1*$sec);
	} else {	
		return $duration;	
	}
}

function get_torrent ($url) {
	if(url_exists($url.".torrent", "torrent")) { // fichier de type *.ogx.torrent
		$torrent = $url.".torrent";
	} elseif(url_exists(str_replace('.'.url_to_ext($url), '', $url).".torrent", "torrent")) { // fichier de type *.torrent
		$torrent = str_replace('.'.url_to_ext($url), '', $url).".torrent";
	} else { $torrent = "";}
	return $torrent;
}

function get_coral ($url) {
	$parsed_url = parse_url ($url);
	$coral=str_replace($parsed_url['host'], $parsed_url['host'].".nyud.net:8090", $url);
	return $coral;
}

function get_jpg ($url) {
	if(url_exists($url.".jpg", "jpg")) { // fichier de type *.ogx.jpg
		$image = $url.".jpg";		
	} elseif(url_exists(str_replace('.'.url_to_ext($url), '', $url).".jpg", "jpg")) { // fichier de type *.jpg
		$image = str_replace('.'.url_to_ext($url), '', $url).".jpg";
	} else { 
		$image = false;
	}
	return $image;
}

function get_first_video ($url, $ext) {
	$handle = @fopen ($url, "r");
	$data = @fread ($handle, 4000);
	if($ext=="xspf") { // Playlist XSPF
		$masque1 = '#<location>(.*?)</location>#i'; 
		preg_match_all("$masque1",$data,$out1,PREG_SET_ORDER);
	} else { // PODCAST	
		$masque1 = '#<enclosure url="(.*?)"#i'; 
		preg_match_all("$masque1",$data,$out1,PREG_SET_ORDER);
	}
	$masque2 = '#<title>(.*?)</title>#i';  
	preg_match_all("$masque2",$data,$out2,PREG_SET_ORDER);
	@fclose ($handle);
	$out[0]= (url_to_ext($out1[0][1])=='xspf') ? $out1[1][1] : $out1[0][1];
	$out[1]=str_replace("]]>", "", str_replace("<![CDATA[", "", $out2[1][1]));
	return $out;
}

?>